﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using NetTopologySuite.Geometries;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using SpectruMeter.Apis.HouseholdApi.DAL;

#nullable disable

namespace SpectruMeter.Apis.HouseholdApi.DAL.Migrations
{
    [DbContext(typeof(DatabaseContext))]
    [Migration("20240122175158_RemoveUselessFields")]
    partial class RemoveUselessFields
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.11")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.HasPostgresExtension(modelBuilder, "postgis");
            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("FacilityHousehold", b =>
                {
                    b.Property<Guid>("FacilitiesId")
                        .HasColumnType("uuid");

                    b.Property<Guid>("HouseholdsId")
                        .HasColumnType("uuid");

                    b.HasKey("FacilitiesId", "HouseholdsId");

                    b.HasIndex("HouseholdsId");

                    b.ToTable("FacilityHousehold");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.Facility", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid>("FacilityGroupId")
                        .HasColumnType("uuid");

                    b.Property<string>("Manufacturer")
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)");

                    b.Property<decimal>("PowerConsumption")
                        .HasColumnType("numeric");

                    b.HasKey("Id");

                    b.HasIndex("FacilityGroupId");

                    b.ToTable("Facilities");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.FacilityGroup", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)");

                    b.HasKey("Id");

                    b.ToTable("FacilityGroups");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.HouseType", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)");

                    b.HasKey("Id");

                    b.ToTable("HouseTypes");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.Household", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<bool>("AcceptContractAutomatically")
                        .HasColumnType("boolean");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("DeviceId")
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)");

                    b.Property<Guid>("HouseTypeId")
                        .HasColumnType("uuid");

                    b.Property<double>("Latitude")
                        .HasColumnType("double precision");

                    b.Property<Point>("Location")
                        .IsRequired()
                        .HasColumnType("geometry");

                    b.Property<double>("Longitude")
                        .HasColumnType("double precision");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)");

                    b.Property<string>("UserId")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)");

                    b.HasKey("Id");

                    b.HasIndex("DeviceId");

                    b.HasIndex("HouseTypeId");

                    b.HasIndex("UserId");

                    b.ToTable("Households");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.Resident", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<DateTimeOffset>("Birthday")
                        .HasColumnType("timestamp with time zone");

                    b.Property<Guid?>("HouseholdId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("HouseholdId");

                    b.ToTable("Residents");
                });

            modelBuilder.Entity("FacilityHousehold", b =>
                {
                    b.HasOne("SpectruMeter.Apis.HouseholdApi.DAL.Models.Facility", null)
                        .WithMany()
                        .HasForeignKey("FacilitiesId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("SpectruMeter.Apis.HouseholdApi.DAL.Models.Household", null)
                        .WithMany()
                        .HasForeignKey("HouseholdsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.Facility", b =>
                {
                    b.HasOne("SpectruMeter.Apis.HouseholdApi.DAL.Models.FacilityGroup", "FacilityGroup")
                        .WithMany("Facilities")
                        .HasForeignKey("FacilityGroupId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("FacilityGroup");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.Household", b =>
                {
                    b.HasOne("SpectruMeter.Apis.HouseholdApi.DAL.Models.HouseType", "HouseType")
                        .WithMany("Households")
                        .HasForeignKey("HouseTypeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("HouseType");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.Resident", b =>
                {
                    b.HasOne("SpectruMeter.Apis.HouseholdApi.DAL.Models.Household", "Household")
                        .WithMany("Residents")
                        .HasForeignKey("HouseholdId");

                    b.Navigation("Household");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.FacilityGroup", b =>
                {
                    b.Navigation("Facilities");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.HouseType", b =>
                {
                    b.Navigation("Households");
                });

            modelBuilder.Entity("SpectruMeter.Apis.HouseholdApi.DAL.Models.Household", b =>
                {
                    b.Navigation("Residents");
                });
#pragma warning restore 612, 618
        }
    }
}
